
%{
open Ast
%}

%start program

%type <Ast.exp> exp exp2 program

%token LLParen LRParen LDot LComma
%token LTrue LFalse LOne LTwo
%token LFn LIf LThen LElse LLetcc LThrow
%token LEof
%token <string> LVar

%%

exp:
  exp2 { $1 }
| exp exp2 { A($1,$2) }

exp2:
  LVar   { S($1) } 
| LTrue  { V(B true)}
| LFalse { V(B false) }
| LLParen LIf exp LThen exp LElse exp LRParen { If($3,$5,$7) }
| LLParen exp LComma exp LRParen { MP($2,$4) }
| LLParen exp LRParen LDot LOne { Fst($2) }
| LLParen exp LRParen LDot LTwo { Snd($2) }
| LLParen LFn    LVar LDot exp LRParen { L($3,$5) }
| LLParen LLetcc LVar LDot exp LRParen { Letcc($3,$5) }
| LLParen LThrow exp LComma exp LRParen { Throw($3,$5) }
| LLParen exp LRParen { $2 }

program:
    exp LEof { $1 }
